// 02-classiying.js


var unit = ee.FeatureCollection('ft:1oBPFeaPFZQsJaRIUYOyWPRzRlmrPYCZzYTvJylAh') //.filter(ee.Filter.eq('crop',1))
// Map.addLayer(ft, {color:'ff0000'})

// sentinel filled with landsat: specify the mapping period
var slope = ee.Terrain.slope(ee.Image("USGS/SRTMGL1_003"))

var start1 = '2016-1-1', end1 = '2016-6-30', start2 = '2015-7-1', end2 = '2015-12-31'
// start1, end1, start2, end2  = '2016-3-1', '2016-5-31', '2015-9-1', '2015-11-30'
// # sentinel 
var sentinel_cloud = function(img) {return img.updateMask(img.select('QA60').lt(1024)).float()}
// var sentinel_cloud = lambda img: img.updateMask(img.select('QA60').lt(1024)).float()
var sentinel1 = ee.ImageCollection("COPERNICUS/S2").filterDate(start1, end1).map(sentinel_cloud).select(['B8','B4','B3','B2'], ['B5','B4','B3','B2'])
var sentinel_compose_1 = sentinel1.median().multiply(1e-4)

var sentinel2 = ee.ImageCollection("COPERNICUS/S2")
.filterDate(start2, end2)
.map(sentinel_cloud)
.select(['B8','B4','B3','B2'], ['B5','B4','B3','B2'])
var sentinel_compose_2 = sentinel2.median().multiply(1e-4)

// # landsat
var landsat_mask = function(img) { return img.updateMask(ee.Algorithms.Landsat.simpleCloudScore(img).select('cloud').lt(40)).float() }
// var landsat_mask = lambda img: img.updateMask(ee.Algorithms.Landsat.simpleCloudScore(img).select('cloud').lt(40)).float()
var s1a = '2013-3-01', e1a = '2013-5-30', s1b = '2014-3-01', e1b = '2014-5-30', s1c = '2015-3-01', e1c = '2015-5-30'
// var s1a, e1a, s1b, e1b, s1c, e1c = '2013-3-01','2013-5-30','2014-3-01','2014-5-30','2015-3-01','2015-5-30'
var s2a = '2013-9-01', e2a = '2013-11-30', s2b = '2014-9-01', e2b = '2014-11-30', s2c = '2015-9-01', e2c = '2015-11-30'
// var s2a, e2a, s2b, e2b, s2c, e2c = '2013-9-01','2013-11-30','2014-9-01','2014-11-30','2015-9-01','2015-11-30'

var landsat1 = ee.ImageCollection('LANDSAT/LC8_L1T_TOA')
.filter(ee.Filter.or(ee.Filter.date(s1a,e1a), ee.Filter.date(s1b,e1b), ee.Filter.date(s1c,e1c)))
.map(landsat_mask).select(['B5','B4','B3','B2'])
var landsat_compose_1 = landsat1.median()

var landsat2 = ee.ImageCollection('LANDSAT/LC8_L1T_TOA')
.filter(ee.Filter.or(ee.Filter.date(s2a,e2a), ee.Filter.date(s2b,e2b), ee.Filter.date(s2c,e2c)))
.map(landsat_mask).select(['B5','B4','B3','B2'])
var landsat_compose_2 = landsat2.median()

var fuse = landsat_compose_1.where(sentinel_compose_1.mask(),sentinel_compose_1)
var image = fuse.select(['B5','B4','B3','B2'], ['A5','A4','A3','A2']) 
.addBands(landsat_compose_2.where(sentinel_compose_2.mask(),sentinel_compose_2))
.addBands(slope)

// if only landsat 8 exits, use following code instead
// var start = '2016-1-1', end = '2016-12-31'
// // var sentinel_cloud = function(img) {return img.updateMask(img.select('QA60').lt(1024)).float()}
// // var s2_compose = ee.ImageCollection("COPERNICUS/S2").filterDate(start, end)
// // .map(sentinel_cloud).select(['B8','B4','B3','B2'], ['B5','B4','B3','B2']).median()

// var landsat_mask = function(img) { return img.updateMask(ee.Algorithms.Landsat.simpleCloudScore(img).select('cloud').lt(40)).float() }
// var image = ee.ImageCollection("LANDSAT/LC8_L1T_TOA").filterDate(start, end)
// .map(landsat_mask).select(['B5','B4','B3','B2']).median()

// var s2viz = {bands: ['B5', 'B4', 'B3'], gamma: 2, opacity:.8}
// Map.addLayer(image, s2viz, 'sentinel-2')
// throw 'ok'

// training
var country = ee.FeatureCollection('ft:1fGODObRcgWotUauiKV_2GlM7ZXX0sdZ5FLTJeALZ') // Africa Country (lengthy)

var samples = ee.FeatureCollection([crop, nc]).flatten()
print(samples.limit(2))
var training = image.reduceRegions(samples, 'mean', 30, null, null, 4)
    .filter(ee.Filter.neq('B5', null))

var randomForest = ee.Classifier.randomForest(600, 0, 1, 0.5, true) //.train(knowledge, 'cropland');
var classifier = randomForest.train(training, 'class', ['B5', 'B4', 'B3', 'B2']);
var classified = image.classify(classifier, 'extent').byte();
Map.addLayer(classified.mask(classified), { palette: '00ff00' })
var assetId = 'randomForest_output'
Export.image.toAsset(classified, null, assetId, null, null, roi, 30, null, null, 1e13)